common: kill _supported_os
[xfstests-dev.git] / tests / ext4 / 007
1 #! /bin/bash
2 # SPDX-License-Identifier: GPL-2.0
3 # Copyright (c) 2015 Oracle, Inc.  All Rights Reserved.
4 #
5 # FS QA Test No. 007
6 #
7 # Create and populate an ext4 filesystem, corrupt the primary superblock, then
8 # see how the kernel and e2fsck deal with it.
9 #
10 seq=`basename $0`
11 seqres=$RESULT_DIR/$seq
12 echo "QA output created by $seq"
13
14 here=`pwd`
15 tmp=/tmp/$$
16 status=1        # failure is the default!
17 trap "_cleanup; exit \$status" 0 1 2 3 15
18
19 _cleanup()
20 {
21     cd /
22     #rm -f $tmp.*
23 }
24
25 # get standard environment, filters and checks
26 . ./common/rc
27 . ./common/filter
28 . ./common/attr
29
30 # real QA test starts here
31 _supported_fs ext4
32
33 _require_scratch
34 test -n "${FORCE_FUZZ}" || _require_scratch_ext4_crc
35 _require_attrs
36
37 rm -f $seqres.full
38 TESTDIR="${SCRATCH_MNT}/scratchdir"
39 TESTFILE="${TESTDIR}/testfile"
40
41 echo "+ create scratch fs"
42 _scratch_mkfs_ext4 > /dev/null 2>&1
43 dumpe2fs -g "${SCRATCH_DEV}" > /dev/null 2>&1 || _notrun "dumpe2fs -g not supported"
44
45 echo "+ mount fs image"
46 _scratch_mount
47 blksz="$(stat -f -c '%s' "${SCRATCH_MNT}")"
48 nr_groups="$(dumpe2fs -g "${SCRATCH_DEV}" 2> /dev/null | tail -n 1 | cut -d : -f 1)"
49 test "${nr_groups}" -gt 0 || _notrun "scratch device not big enough for backup superblocks"
50 backup_sb="$(dumpe2fs -g "${SCRATCH_DEV}" 2> /dev/null | awk -F ':' 'BEGIN {x = 0;} {if (x == 0 && int($3) > 1) {print $3; x++;}}')"
51
52 echo "+ make some files"
53 mkdir -p "${TESTDIR}"
54 for x in `seq 1 128`; do
55         touch "${SCRATCH_MNT}/junk.${x}"
56         inode="$(stat -c '%i' "${SCRATCH_MNT}/junk.${x}")"
57         if [ "$x" -gt 64 ] && [ "$((inode % 64))" -eq 0 ]; then
58                 mv "${SCRATCH_MNT}/junk.${x}" "${TESTFILE}.1"
59                 break
60         fi
61 done
62 for x in `seq 2 64`; do
63         touch "${TESTFILE}.${x}"
64 done
65 umount "${SCRATCH_MNT}"
66
67 echo "+ check fs"
68 e2fsck -fn "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "fsck should not fail"
69
70 echo "+ corrupt image"
71 dumpe2fs -g "${SCRATCH_DEV}" 2>/dev/null | awk -F ':' '{if ($1 == 0) {print $3}}' | while read blk; do
72         debugfs -w -R "zap_block ${blk}" "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "primary sb fuzz failed"
73 done
74
75 echo "+ mount image"
76 _try_scratch_mount 2> /dev/null && _fail "mount should not succeed"
77
78 echo "+ repair fs"
79 # Have to specify backup sb and blocksize here so we don't pick up superblocks
80 # scattered elsewhere on the scratch device.
81 echo e2fsck -f -y -B "${blksz}" -b "${backup_sb}" "${SCRATCH_DEV}" >> $seqres.full 2>&1
82 e2fsck -f -y -B "${blksz}" -b "${backup_sb}" "${SCRATCH_DEV}" >> $seqres.full 2>&1
83
84 echo "+ mount image (2)"
85 _scratch_mount
86
87 echo "+ chattr -R -i"
88 $CHATTR_PROG -R -f -i "${SCRATCH_MNT}/"
89
90 echo "+ modify files (2)"
91 broken=0
92 for x in `seq 1 64`; do
93         test -e "${TESTFILE}.${x}" || continue
94         stat "${TESTFILE}.${x}" >> /dev/null 2>&1
95         test $? -ne 0 && broken=1
96         echo moo | dd oflag=append of="${TESTFILE}.${x}" 2>/dev/null
97         test $? -ne 0 && broken=1
98 done
99 echo "broken: ${broken}"
100 umount "${SCRATCH_MNT}"
101
102 echo "+ check fs (2)"
103 e2fsck -fn "${SCRATCH_DEV}" >> $seqres.full 2>&1 || _fail "fsck should not fail"
104
105 status=0
106 exit